/* gus-dj.c -- disables GUS joystick interface of GUS rev 3.4+
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>

/* change this to reflect your GUS IO base port (210 - 260) */
#define GUS_BASE 0x260
#define MIXER GUS_BASE
#define REG_CONTROLS GUS_BASE+0x0F
#define IRQDMA_REG GUS_BASE+0x0B
#define SELECT_REG  GUS_BASE+0x103
#define GLOBAL_HIGH GUS_BASE+0x105

extern unsigned char inb(unsigned short int port);
extern void outb(unsigned char val, unsigned short int port);

int main(void)
{
    int result;
    
    if (-1 == ioperm(GUS_BASE,0x10,0xFF))
    {
	printf("ioperm failed -- needs suid root\n");
	exit(1);
    }
    if (-1 == ioperm(GUS_BASE+0x100, 0x10, 0xFF))
    {
	printf("ioperm failed -- needs suid root\n");
	exit(1);
    }

    outb(0x4c+0x80, SELECT_REG);
    result = inb(GLOBAL_HIGH);
    if (result != 0x07)
    {
	printf("GUS not initialized or not found at port 0x%03x.\n", GUS_BASE);
	exit(2);
    }
    	
    outb(0x06,REG_CONTROLS);  /* select jumper reg */
    outb(0x0B,MIXER);         /* enable latches */
    outb(0x02,IRQDMA_REG);    /* disable joystick */
    outb(0x00,REG_CONTROLS);  /* reselect IRQ/DMA reg */
    exit(0);
}
    
